# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: inventory.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import List, Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class Inventory(betterproto.Message):
    id: "_common__.UserId" = betterproto.message_field(1)
    items: List["Item"] = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemList(betterproto.Message):
    items: List["Item"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemDefList(betterproto.Message):
    item_defs: List["ItemDefinition"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemIdList(betterproto.Message):
    item_ids: List["_common__.ItemId"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemDefinition(betterproto.Message):
    type: str = betterproto.string_field(2)
    tags: List[str] = betterproto.string_field(3)
    food: "Food" = betterproto.message_field(4, group="itemContent")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Item(betterproto.Message):
    id: int = betterproto.int32_field(1)
    item_def: "ItemDefinition" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Effect(betterproto.Message):
    buff: "Buff" = betterproto.message_field(1, group="effect")
    rec: "Recovery" = betterproto.message_field(2, group="effect")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Buff(betterproto.Message):
    """effect types temporary increase of sth."""

    type: str = betterproto.string_field(1)
    value: float = betterproto.float_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Recovery(betterproto.Message):
    """recovery of resource"""

    type: str = betterproto.string_field(1)
    value: float = betterproto.float_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Page(betterproto.Message):
    size: int = betterproto.int32_field(1)
    count: int = betterproto.int32_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Food(betterproto.Message):
    effects: List["Effect"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemType(betterproto.Message):
    type: str = betterproto.string_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class AddItem(betterproto.Message):
    item: "Item" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetItem(betterproto.Message):
    id: "_common__.ItemId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class GetInventory(betterproto.Message):
    user_id: "_common__.UserId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class AddItemToInventoryCall(betterproto.Message):
    user_id: "_common__.UserId" = betterproto.message_field(1)
    item_id: "_common__.ItemId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class UpdateItem(betterproto.Message):
    item: "Item" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class DeleteItem(betterproto.Message):
    id: "_common__.ItemId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemDeletedEvent(betterproto.Message):
    item_id: "_common__.ItemId" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemAddedEvent(betterproto.Message):
    item: "Item" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemUpdatedEvent(betterproto.Message):
    item: "Item" = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class ItemEvent(betterproto.Message):
    added_event: "ItemAddedEvent" = betterproto.message_field(1, group="event")
    delete_event: "ItemDeletedEvent" = betterproto.message_field(2, group="event")
    update_event: "ItemUpdatedEvent" = betterproto.message_field(3, group="event")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class InventoryServiceCall(betterproto.Message):
    add_item: "AddItem" = betterproto.message_field(1, group="method")
    get_item: "GetItem" = betterproto.message_field(2, group="method")
    get_inventory: "GetInventory" = betterproto.message_field(3, group="method")
    update_item: "UpdateItem" = betterproto.message_field(4, group="method")
    delete_item: "DeleteItem" = betterproto.message_field(5, group="method")
    meta_data: "_common__.MetaData" = betterproto.message_field(6)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class InventoryServiceResponse(betterproto.Message):
    item_id: "_common__.ItemId" = betterproto.message_field(1, group="data")
    item: "Item" = betterproto.message_field(2, group="data")
    status: "_common__.ResponseStatus" = betterproto.message_field(3, group="data")
    inv: "Inventory" = betterproto.message_field(4, group="data")
    meta_data: "_common__.MetaData" = betterproto.message_field(5)

    def __post_init__(self) -> None:
        super().__post_init__()


class ItemServiceStub(betterproto.ServiceStub):
    async def create_item_by_type(self, *, type: str = "") -> "_common__.ItemId":

        request = ItemType()
        request.type = type

        return await self._unary_unary(
            "/item.ItemService/CreateItemByType", request, _common__.ItemId
        )

    async def add_item(
        self, *, id: int = 0, item_def: "ItemDefinition" = None
    ) -> "_common__.ItemId":

        request = Item()
        request.id = id
        if item_def is not None:
            request.item_def = item_def

        return await self._unary_unary(
            "/item.ItemService/AddItem", request, _common__.ItemId
        )

    async def add_item_to_inventory(
        self, *, user_id: "_common__.UserId" = None, item_id: "_common__.ItemId" = None
    ) -> "_common__.ResponseStatus":

        request = AddItemToInventoryCall()
        if user_id is not None:
            request.user_id = user_id
        if item_id is not None:
            request.item_id = item_id

        return await self._unary_unary(
            "/item.ItemService/AddItemToInventory", request, _common__.ResponseStatus
        )

    async def get_item(self, *, id: int = 0) -> "Item":

        request = _common__.ItemId()
        request.id = id

        return await self._unary_unary("/item.ItemService/GetItem", request, Item)

    async def get_inventory(self, *, id: int = 0) -> "Inventory":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/item.ItemService/GetInventory", request, Inventory
        )

    async def update_item(
        self, *, id: int = 0, item_def: "ItemDefinition" = None
    ) -> "_common__.ResponseStatus":

        request = Item()
        request.id = id
        if item_def is not None:
            request.item_def = item_def

        return await self._unary_unary(
            "/item.ItemService/UpdateItem", request, _common__.ResponseStatus
        )

    async def delete_item(self, *, id: int = 0) -> "_common__.ResponseStatus":

        request = _common__.ItemId()
        request.id = id

        return await self._unary_unary(
            "/item.ItemService/DeleteItem", request, _common__.ResponseStatus
        )

    async def get_item_definitions(
        self, *, size: int = 0, count: int = 0
    ) -> "ItemDefList":

        request = Page()
        request.size = size
        request.count = count

        return await self._unary_unary(
            "/item.ItemService/GetItemDefinitions", request, ItemDefList
        )


from .. import common as _common__
